# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::MediaServices::Mgmt::V2020_05_01
  module Models
    #
    # Model object.
    #
    #
    class EdgeUsageDataCollectionPolicy

      include MsRestAzure

      # @return [String] Usage data collection frequency in ISO 8601 duration
      # format e.g. PT10M , PT5H.
      attr_accessor :data_collection_frequency

      # @return [String] Usage data reporting frequency in ISO 8601 duration
      # format e.g. PT10M , PT5H.
      attr_accessor :data_reporting_frequency

      # @return [String] Maximum time for which the functionality of the device
      # will not be hampered for not reporting the usage data.
      attr_accessor :max_allowed_unreported_usage_duration

      # @return [EdgeUsageDataEventHub] Details of Event Hub where the usage
      # will be reported.
      attr_accessor :event_hub_details


      #
      # Mapper for EdgeUsageDataCollectionPolicy class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'EdgeUsageDataCollectionPolicy',
          type: {
            name: 'Composite',
            class_name: 'EdgeUsageDataCollectionPolicy',
            model_properties: {
              data_collection_frequency: {
                client_side_validation: true,
                required: false,
                serialized_name: 'dataCollectionFrequency',
                type: {
                  name: 'String'
                }
              },
              data_reporting_frequency: {
                client_side_validation: true,
                required: false,
                serialized_name: 'dataReportingFrequency',
                type: {
                  name: 'String'
                }
              },
              max_allowed_unreported_usage_duration: {
                client_side_validation: true,
                required: false,
                serialized_name: 'maxAllowedUnreportedUsageDuration',
                type: {
                  name: 'String'
                }
              },
              event_hub_details: {
                client_side_validation: true,
                required: false,
                serialized_name: 'eventHubDetails',
                type: {
                  name: 'Composite',
                  class_name: 'EdgeUsageDataEventHub'
                }
              }
            }
          }
        }
      end
    end
  end
end
