# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::MediaServices::Mgmt::V2020_05_01
  module Models
    #
    # A Media Services account.
    #
    class MediaService < TrackedResource

      include MsRestAzure

      # @return The Media Services account ID.
      attr_accessor :media_service_id

      # @return [Array<StorageAccount>] The storage accounts for this resource.
      attr_accessor :storage_accounts

      # @return [StorageAuthentication] Possible values include: 'System',
      # 'ManagedIdentity'
      attr_accessor :storage_authentication

      # @return [AccountEncryption] The account encryption properties.
      attr_accessor :encryption

      # @return [MediaServiceIdentity] The Managed Identity for the Media
      # Services account.
      attr_accessor :identity

      # @return [SystemData] The system metadata relating to this resource.
      attr_accessor :system_data


      #
      # Mapper for MediaService class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'MediaService',
          type: {
            name: 'Composite',
            class_name: 'MediaService',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              location: {
                client_side_validation: true,
                required: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              media_service_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.mediaServiceId',
                type: {
                  name: 'String'
                }
              },
              storage_accounts: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.storageAccounts',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StorageAccountElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'StorageAccount'
                      }
                  }
                }
              },
              storage_authentication: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.storageAuthentication',
                type: {
                  name: 'String'
                }
              },
              encryption: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.encryption',
                type: {
                  name: 'Composite',
                  class_name: 'AccountEncryption'
                }
              },
              identity: {
                client_side_validation: true,
                required: false,
                serialized_name: 'identity',
                type: {
                  name: 'Composite',
                  class_name: 'MediaServiceIdentity'
                }
              },
              system_data: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'systemData',
                type: {
                  name: 'Composite',
                  class_name: 'SystemData'
                }
              }
            }
          }
        }
      end
    end
  end
end
